
;Console Input with Prompt and Default Strings
;DednDave 6-2011

        .XCREF
        .NOLIST
        INCLUDE \masm32\include\masm32rt.inc
        .LIST

;---------------------------------------------------------------------------------------------

ConInDefStr PROTO :DWORD,:DWORD,:DWORD,:DWORD

;---------------------------------------------------------------------------------------------

        .DATA

Prmpt   db 'Enter your name: ',0  ;prompt string
DefStr  db 'Rumpelstiltskin',0    ;default entry string

;--------------------------------

        .DATA?

InBuff  db 256 dup(?)             ;input buffer

;---------------------------------------------------------------------------------------------

        .CODE

_main   PROC

        INVOKE  ConInDefStr,offset InBuff,sizeof InBuff-1,offset Prmpt,offset DefStr

        print chr$(13,10)
        print offset InBuff
        print chr$(13,10)
        inkey
        exit

_main   ENDP

;---------------------------------------------------------------------------------------------

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

ConInDefStr PROC lpBuf:DWORD,dwLen:DWORD,szPrmptStr,szDefStr:DWORD

;Console Input with Prompt and Default Strings
;DednDave 6-2011
;
;Call With: lpBuf      = address of input buffer
;           dwLen      = length of input buffer, less 1 for the terminator
;           szPrmptStr = address of prompt string
;           szDefStr   = address of default input string
;
;  Returns: EAX        = length of user-input (buffer) string

;[EBP+28] = szDefStr
;[EBP+24] = szPrmtpStr
;[EBP+20] = dwLen
;[EBP+16] = lpBuf
;[EBP+12] = RET address
;[EBP+8]  = saved EBX value
;[EBP+4]  = saved ESI value
;[EBP]    = saved EBP value
;[EBP-4]  = standard input handle
;[EBP-8]  = length of default string

        push    ebx
        push    esi
        push    ebp
        mov     ebp,esp
        INVOKE  GetStdHandle,STD_INPUT_HANDLE
        push    eax                           ;[EBP-4] = standard input handle
        print   [ebp+24]                      ;szPrmptStr
        mov     esi,[ebp+28]                  ;szDefStr
        push    1
        INVOKE  StrLen,esi
        pop     ecx                           ;ECX = 1 (TRUE, KEY_EVENT, wRepeatCount)
        xor     edx,edx                       ;EDX = 0 (FALSE)
        push    eax                           ;[EBP-8] = length of szDefStr
        jmp short Cids01

Cids00: movzx   ebx,byte ptr [esi+eax]
        shl     ebx,16

;key up record

        push    edx                           ;KEY_EVENT_RECORD.dwControlKeyState = 0
        push    ebx                           ;KEY_EVENT_RECORD.wVirtualScanCode = 0, char = character
        push    ecx                           ;KEY_EVENT_RECORD.wRepeatCount = 1, wVirtualKeyCode = 0
        push    edx                           ;KEY_EVENT_RECORD.bKeyDown = FALSE (key up)
        push    ecx                           ;INPUT_RECORD.EventType = KEY_EVENT

;key down record

        push    edx                           ;KEY_EVENT_RECORD.dwControlKeyState = 0
        push    ebx                           ;KEY_EVENT_RECORD.wVirtualScanCode = 0, char = character
        push    ecx                           ;KEY_EVENT_RECORD.wRepeatCount = 1, wVirtualKeyCode = 0
        push    ecx                           ;KEY_EVENT_RECORD.bKeyDown = TRUE (key down)
        push    ecx                           ;INPUT_RECORD.EventType = KEY_EVENT

Cids01: dec     eax
        jns     Cids00

        INVOKE  FlushConsoleInputBuffer,[ebp-4]
        mov     eax,[ebp-8]
        mov     edx,esp
        shl     eax,1
        jz      Cids02

        push    ecx
        INVOKE  WriteConsoleInput,[ebp-4],edx,eax,esp
        pop     eax

Cids02: push    ecx
        mov     eax,esp
        INVOKE  ReadConsole,[ebp-4],[ebp+16],[ebp+20],eax,NULL
        pop     eax
        leave
        pop     esi
        pop     ebx
        ret     16

ConInDefStr ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;---------------------------------------------------------------------------------------------

        END     _main

